{$C Fixed,Preload,Permanent}
USES WinProcs,WinCrt,MMSystem;
{$R DCFDecod.RES}
CONST
  INPORT:Word=$200;
  InMask:Word=32;{JoyA; 128 JoyB}

  Hour:Byte=0;
  Min:Byte=0;
  Day:Byte=0;
  DoW:Byte=0;
  Month:Byte=0;
  Year:Byte=0;

  Rec1:ARRAY[1..2]OF Longint=(0,0);
  index:Byte=0;
  OffTime:Word=0;
  CntDwn:Byte=2;

PROCEDURE TimeIntr(w1,w2:Word;dw1,dw2,dw3:Longint);EXPORT;ASSEMBLER;
ASM
        mov  dx,InPort
        in   al,dx
        test ax,InMask
        jnz  @1
        ; {Bit nicht gesetzt}
        inc  OffTime
        jmp  @Exit
    @1: ; { Bit gesetzt ==> LastOffTime auswerten: }
        ; { (30..38:Minute; 14..18:Low; 6..10:High }
        mov  ax,OffTime
        or   ax,ax
        je   @Exit
        mov  OffTime,0
        ; {Letztes Event war MinutenWechsel?}
        cmp  ax,50
        ja   @Error
        cmp  ax,22
        jb   @2
        cmp  Index,58
        jne  @Error
        ; {Letztes Bit fr Checksumme berechnen}
        cmp  ax,30
        ja   @E1
        or   word ptr Rec1+6,$0400
    @E1:; {Check Bits: 1-14=0; 20=1}
        mov  ax,word ptr Rec1
        and  ax,$7FFE
        or   ax,ax
        jne  @Error
        {test word ptr Rec1+2,4
        jz   @Error
        ; {Checksummen 21-27}
        mov  cx,7
        xor  dx,dx
        mov  ax,word ptr Rec1+2
        shr  ax,5
    @l1:shr  ax,1
        adc  dx,0
        loop @l1
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Checksummen 29-34}
        mov  cx,6
        xor  dx,dx
        mov  ax,word ptr Rec1+3
        shr  ax,5
    @l2:shr  ax,1
        adc  dx,0
        loop @l2
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Checksummen 36-57}
        mov  cx,22
        xor  dx,dx
        DB   66h; mov ax,word ptr Rec1+4
        DB   66h; shr ax,4
    @l3:DB   66h; shr ax,1
        adc  dx,0
        loop @l3
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Zeit dekodieren}
        ; {Minuten: Bits 21..24 Lo; 25-27..Hi; 28 Paritt}
        mov  ax,word ptr Rec1+2 ; {Bits 16-31}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,7
        aad  ; {bcd>bin}
        cmp  al,59
        ja   @Error
        mov  Min,al
        ; {Stunden: Bits 29..32 Lo; 33,34..Hi; 35 Paritt}
        mov  ax,word ptr rec1+3 ; {Bits 24-39}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,3
        aad  ; {bcd>bin}
        cmp  al,23
        ja   @Error
        mov  Hour,al
        ; {Tag: Bits 36..39 Lo; 40,41..Hi}
        mov  ax,word ptr rec1+4 ; {Bits 32-47}
        shr  ax,4
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,3
        aad  ; {bcd>bin}
        cmp  al,31
        ja   @Error
        mov  Day,al
        ; {Wochentag: Bits 42..44}
        mov  ax,word ptr rec1+5 ; {Bits 40-55}
        shr  ax,2
        and  al,7
        mov  DoW,al
        ; {Monat: Bits 45..48 Lo; 49 Hi;}
        mov  ax,word ptr rec1+5 ; {Bits 40-55}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,1
        aad  ; {bcd>bin}
        cmp  al,12
        ja   @Error
        mov  Month,al
        ; {Jahr: Bits 50..53 Lo; 54-57..Hi; 58 Paritt fr Tag,Wochentag,Monat,Jahr}
        mov  ax,word ptr rec1+6 ; {Bits 48-63}
        shr  ax,2
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,15
        aad  ; {bcd>bin}
        cmp  al,99
        ja   @Error
        mov  Year,al

        ; {feetich}
        dec  CntDwn
        jnz  @Error
        mov  cntDwn,10
        ; {SetTime}
        MOV  CH,Hour
        MOV  CL,Min
        XOR  DX,DX
        MOV  AH,2DH
        INT  21H
        ; {SetDate}
        MOV  CX,1900
        ADD  CL,Year
        CMP  Year,94
        JA   @D1
        ADD  CX,100
    @D1:MOV  DH,Month
        MOV  DL,Day
        MOV  AH,2BH
        INT  21H
        ; {SetDate (DOS)}
        MOV  AL,Year
        MOV  AH,AL
        AND  AL,15
        SHR  AH,4
        AAD
        MOV  CL,AL
        MOV  CX,1900
        CMP  CL,94
        JA   @D2
        ADD  CX,100
    @D2:MOV  AL,Month
        MOV  AH,AL
        AND  AL,15
        SHR  AH,4
        AAD
        MOV  DH,AL
        MOV  AL,Day
        MOV  AH,AL
        AND  AL,15
        SHR  AH,4
        AAD
        MOV  DL,AL
        MOV  AH,2BH
        INT  21H
        jmp  @Error
        ; {Letztes Event war Low?}
    @2: cmp  ax,18
        ja   @Error
        cmp  ax,14
        jb   @3
        inc  index
        jmp  @Exit
        ; {Letztes Event war High?}
    @3: cmp  ax,10
        ja   @Error
        cmp  ax,6
        jb   @Error
        mov  cl,Index
        DB   66h; xor ax,ax
        inc  ax
        DB   66h; shl ax,cl
        inc  Index
        cmp  cl,32
        jb   @@1
        DB   66h; or word ptr Rec1+4,ax
        jmp @exit
    @@1:
        DB   66h; or word ptr Rec1,ax
        jmp  @Exit
        ; {Synchronisation verloren!!!}
    @Error:
        mov  index,0
        mov  word ptr Rec1,0
        mov  word ptr Rec1+2,0
        mov  word ptr Rec1+4,0
        mov  word ptr Rec1+6,0
    @Exit:
END;


CONST LastTime:Longint=0;
VAR Proc:tTimeCallback;
    TEvent:Word;
BEGIN
  @Proc:=MakeProcInstance(@TimeIntr,hInstance);
  TEvent:=TimeSetEvent(55,1,Proc,0,Time_periodic);
  REPEAT
    IF GetTickCount<>LastTime THEN
    BEGIN
      LastTime:=GetTickCount;
      Gotoxy(1,1);
      Write(Dow:2,',',Day:3,'.',Month:2,'.',Year:2,Hour:3,':',Min:2,'.',Index:2,' Min to go:',CntDwn:2);
    END;
  UNTIL KeyPressed;
  TimeKillEvent(TEvent);
  FreeProcInstance(@Proc);
END.